package org.mercury_im.messenger.entity;

import java.util.UUID;

public class IAccount implements Account {

    protected UUID id;
    protected String address;
    protected String password;
    protected String host;
    protected int port;
    protected boolean enabled;

    public IAccount() {
        this(UUID.randomUUID());
    }

    public IAccount(UUID id) {
        this.id = id;
    }

    public static Account createUnassignedAccount() {
        return new IAccount(Account.UNASSIGNED);
    }

    @Override
    public void setId(UUID id) {
        this.id = id;
    }

    @Override
    public UUID getId() {
        return id;
    }

    @Override
    public void setAddress(String address) {
        this.address = address;
    }

    @Override
    public String getAddress() {
        return address;
    }

    @Override
    public void setPassword(String password) {
        this.password = password;
    }

    @Override
    public String getPassword() {
        return password;
    }

    @Override
    public void setHost(String host) {
        this.host = host;
    }

    @Override
    public String getHost() {
        return host;
    }

    @Override
    public void setPort(int port) {
        this.port = port;
    }

    @Override
    public int getPort() {
        return port;
    }

    @Override
    public void setEnabled(boolean enabled) {
        this.enabled = enabled;
    }

    @Override
    public boolean isEnabled() {
        return enabled;
    }
}
