package org.mercury_im.messenger.entity.chat;

/**
 * Interface that describes typical preferences in the context of a chat.
 *
 * An implementation can be found as {@link IChatPreferences}.
 */
public interface ChatPreferences {

    NotificationPreferences getNotificationPreference();

    void setNotificationPreference(NotificationPreferences notificationPreferences);

    boolean isTypingNotificationsSupported();

    void setTypingNotificationsSupported(boolean typingNotificationsSupported);

    boolean isSendTypingNotificationsEnabled();

    void setSendTypingNotificationsEnabled(boolean sendTypingNotifications);

    boolean isReadNotificationsSupported();

    void setReadNotificationsSupported(boolean readNotificationsSupported);

    boolean isSendReadNotifications();

    void setSendReadNotifications(boolean sendReadNotifications);


    interface NotificationPreferences {

        boolean isNotifyOnMessage();

        void setNotifyOnMessage(boolean notify);

        boolean isNotifyOnMention();

        void setNotifyOnMention(boolean notify);
    }
}
