package org.mercury_im.messenger.entity.chat;

import org.mercury_im.messenger.entity.Account;
import org.mercury_im.messenger.entity.contact.Peer;

import java.util.Set;
import java.util.UUID;

public class IGroupChat implements GroupChat {

    private UUID id;
    private Account account;
    private String roomAddress;
    private String roomName;
    protected ChatPreferences preferences;
    protected Set<Peer> participants;

    public IGroupChat() {
        this(UUID.randomUUID());
    }

    public IGroupChat(UUID id) {
        this.id = id;
    }

    @Override
    public Set<Peer> getParticipants() {
        return participants;
    }

    @Override
    public void setParticipants(Set<Peer> participants) {
        this.participants = participants;
    }

    @Override
    public String getRoomAddress() {
        return roomAddress;
    }

    @Override
    public void setRoomAddress(String roomAddress) {
        this.roomAddress = roomAddress;
    }

    @Override
    public String getRoomName() {
        return roomName;
    }

    @Override
    public void setRoomName(String roomName) {
        this.roomName = roomName;
    }

    @Override
    public UUID getId() {
        return id;
    }

    @Override
    public void setId(UUID id) {
        this.id = id;
    }

    @Override
    public Account getAccount() {
        return account;
    }

    @Override
    public void setAccount(Account account) {
        this.account = account;
    }


    @Override
    public ChatPreferences getChatPreferences() {
        return preferences;
    }

    @Override
    public void setChatPreferences(ChatPreferences chatPreferences) {
        this.preferences = chatPreferences;
    }

}
