package org.mercury_im.messenger.entity.message;

import java.util.Date;
import java.util.List;
import java.util.UUID;

public interface Message {

    UUID getId();

    void setId(UUID id);

    String getSender();

    void setSender(String address);

    String getRecipient();

    void setRecipient(String recipient);

    Date getTimestamp();

    void setTimestamp(Date timestamp);

    MessageDirection getDirection();

    void setDirection(MessageDirection direction);

    default boolean isIncoming() {
        return getDirection() == MessageDirection.incoming;
    }

    List<PayloadContainer> getMessagePayloads();

    void setMessagePayloads(List<PayloadContainer> payloadContainers);

    MessageDeliveryState getDeliveryState();

    void setDeliveryState(MessageDeliveryState deliveryState);

    MessageMetadata getMetadata();

    void setMetadata(MessageMetadata metadata);
}
